package org.omg.CORBA_2_3.portable;

import java.security.AccessController;
import java.security.PrivilegedAction;
import org.omg.CORBA.portable.BoxedValueHelper;
import org.omg.CORBA.NO_IMPLEMENT;
import java.io.Serializable;
import java.io.SerializablePermission;

public abstract class OutputStream extends org.omg.CORBA.portable.OutputStream
{
    private static final String ALLOW_SUBCLASS_PROP = "jdk.corba.allowOutputStreamSubclass";
    private static final boolean allowSubclass;
    
    private static Void checkPermission() {
        SecurityManager securityManager = System.getSecurityManager();
        if (securityManager != null && !OutputStream.allowSubclass) {
            securityManager.checkPermission(new SerializablePermission("enableSubclassImplementation"));
        }
        return null;
    }
    
    private OutputStream(Void void1) {
    }
    
    public OutputStream() {
        this(checkPermission());
    }
    
    public void write_value(Serializable s) {
        throw new NO_IMPLEMENT();
    }
    
    public void write_value(Serializable s, Class clazz) {
        throw new NO_IMPLEMENT();
    }
    
    public void write_value(Serializable s, String s2) {
        throw new NO_IMPLEMENT();
    }
    
    public void write_value(Serializable s, BoxedValueHelper boxedValueHelper) {
        throw new NO_IMPLEMENT();
    }
    
    public void write_abstract_interface(Object o) {
        throw new NO_IMPLEMENT();
    }
    
    static {
        allowSubclass = (boolean)AccessController.doPrivileged(new PrivilegedAction<Boolean>() {
            @Override
            public Boolean run() {
                String property = System.getProperty("jdk.corba.allowOutputStreamSubclass");
                return Boolean.valueOf(property != null && !property.equalsIgnoreCase("false"));
            }
        });
    }
}
